/*		
	bin2inc.c:
	
	liest eine Binrdatei und schreibt den Inhalt als Array in eine Textdatei.
	
	Compilieren:
	
	gcc -o bin2inc bin2inc.c
*/

#include <stdio.h>
#include <stdlib.h>

#define BYTE unsigned char
#define NUM_HEX	10

int main ( int argc, char** argv )
{
	FILE* infile;
	
	size_t size, bytes_read;
	long i;
	BYTE* buffer;
	
	if ( NULL == ( infile = fopen (argv[1],"rb")))
	{
		fprintf ( stderr, "%s: fopen failed!.\n",argv[1]);
		exit(1);	
	}
	
	fseek (infile, 0, SEEK_END);
    size = ftell (infile);
	fseek (infile, 0, SEEK_SET);
	
	if ( NULL == ( buffer = malloc ( (size_t)size)))
	{
		fprintf ( stderr, "malloc failed!.\n");
		exit(1);
	}
	
	if ((bytes_read=fread ( buffer, 1, size, infile)) != (size_t) size )
	{
		fprintf ( stderr, "fread returned %d!.\n", (unsigned)bytes_read);
		exit(1);
	}

	fprintf( stdout, "unsigned char compiled_code [] = {\n");
	fflush ( stdout );

	for ( i=0; i < (long) size; i++ )
	{
		fprintf(stdout, "%s0x%02x%s%s",
		/* tab? */ 		(i % NUM_HEX ? "" : "\t"),
		/* hex */ 		buffer[i],
		/* comma? */ 	(i+1 < size ? ", " : ""),
		/* newline */ 	((i+1) % NUM_HEX ? "" : "\n"));		
		
		fflush(stdout);
	}
	
	fprintf( stdout, "\n};\n");

	free ( buffer );	
	return 0;
}